//
// THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY
// BE USED OR COPIED ONLY IN ACCORDANCE WITH THE TERMS
// OF SUCH LICENSE.
//
//
// COPYRIGHT (c) 1997 BY DIGITAL EQUIPMENT CORPORATION.
// ALL RIGHTS RESERVED.
//

import dec.trek.RunLog;
import java.io.*;

//
//
// FindLog. Write find results using this class
//
//
public final class FindLog extends RunLog
{
	// Constructor
	FindLog(String sug, int logtype)
	{
		super(sug, logtype);
	}

	// Do the various find entries of form entry-code string
	void writeClass(String name)
	{
		writeString(name, Jtu.fit_class);
	}
	void writeRefLocal(String name)
	{
		writeString(name, Jtu.fit_reflocal);
	}
	void writeField(String name)
	{
		writeString(name, Jtu.fit_field);
	}
	void writeInMethod(String name)
	{
		writeString(name, Jtu.fit_inmethod);
	}
	void writeLocal(String name)
	{
		writeString(name, Jtu.fit_local);	// For locals by-def
	}
	void writeMethod(String name)
	{
		writeString(name, Jtu.fit_method);
	}
	void writeRef(String name)
	{
		writeString(name, Jtu.fit_ref);
	}
	void writeRefNear(String name)
	{
		writeString(name, Jtu.fit_refnear);
	}
	void writeSeparator()
	{
		writeString("__", Jtu.fit_separator);
	}

	// Write first item of an entry that starts with a string
	// str = string to start entry with
	// fit = type code for entry
	private void writeString(String str, int fit)
	{

		// Write the item (and thread id if requested)
		//
		try {
			dataStream.writeByte(fit);
			dataStream.writeUTF(str);
		}

		catch (Exception e) {
			e.printStackTrace();
			throw new RuntimeException("Could not log item");
		}
		writeEntry();
	}

}

