//
// THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND  MAY
// BE USED OR COPIED ONLY IN ACCORDANCE WITH THE TERMS
// OF SUCH LICENSE.
//
//
// COPYRIGHT (c) 1997 BY DIGITAL EQUIPMENT CORPORATION.
// ALL RIGHTS RESERVED.
//

package dec.trek;

//
//
// ArrayInit. Execute an array initialization
//
//
final class ArrayInit extends Vmi 
{
	Datum outermost;

	// Construct envir for analyzing array
	ArrayInit(Statement stmt)
	{
		init(stmt);
		inst = stmt.firstInstruction();
	}

	// Process new-array inst, creating an array for storing init vals into
	// dims = # of dims to alloc now (or 0 for newarray inst)
	// multi = true says multianewarry
	// Top of stack is size of each dimension being alloc now
	protected void newArray(int dims, boolean multi)
	{
		if (multi && dims>1)
			throw new TrekException("multianewarray 2+ in array-init statement");

		// For default values, need to know data type of element
		String desc;
		if (dims==0)
			desc = String.valueOf(descs[inst.readUnsignedByte(inst.start+1)]);
		else desc = "L;";

		// Create and push the new array, saving top-level array if applic
		Datum dtm = new Datum("", desc);
		dtm.arrayInit = new String[pop().intVal];
		if (outermost==null) outermost = dtm;
		push(dtm);
	}

	// Process xastore inst, leaving {...} on stack
	// val = datum of val to store into specified array
	// idx = index to store it al
	// arr = datum of array to store it into
	protected void storeElement(Datum val, Datum idx, Datum arr)
	{
		String elem = val.arrayInit!=null
			? stringify(val) : mapConstant(val, outermost.desc);
		arr.arrayInit[idx.intVal] = elem;
	}

	// When storing an array as array element, need it in string form
	String stringify(Datum arr)
	{
		// Init where string form of array will be built
		int size = arr.arrayInit.length;
		StringBuffer sb = new StringBuffer(size*10);
		sb.append("{");

		// Process array's elements
		for (int i=0; i<size; i++) {
			String str = arr.arrayInit[i];
			sb.append(str!=null ? str : getDefaultValue(arr.desc));
			sb.append(i==size-1 ? "}" : ", ");
		}
		return sb.toString();
	}

}

