//
// THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND  MAY
// BE USED OR COPIED ONLY IN ACCORDANCE WITH THE TERMS
// OF SUCH LICENSE.
//
//
// COPYRIGHT (c) 1997 BY DIGITAL EQUIPMENT CORPORATION.
// ALL RIGHTS RESERVED.
//

package dec.trek;
import java.util.Vector;

//
//
// Block. All the state info to keep track of open blocks in a method.
// Some of the info is relevant only for specific types. For ex,
// the cas* fields are meaningful only if type=ST_ENDSWITCH.
// Bottom and end are the same unless there is code at the bottom (as
// in loop). Then bottom is start of end-loop code, and end is
// best guess at to its end (usually end of encompassing blk).
//
final class Block 
{
	int bottom;					// Start of bottom of blk.
	Vector cases;				// Describes all the cases of a switch
	int casidx;					// Curr item of cases
	int end;					// Where break out of blk would go
	String endstr;				// Source code of blk's end (ie. "} // End ..."
	boolean endAsap;			// Loop with branch-less bot & optim Contin
	Local loc;					// Catch var if no lvt & building Catch blk
	int postHandlers;			// For end of curr try/handlers	WITHIN blk
	Statement top;				// Statement at top of breakable blk
	ExceptionHandler lastTry;	// Last Try see at this level
	int type;					// Type of blk (ST_END*)
}

