//
// THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND  MAY
// BE USED OR COPIED ONLY IN ACCORDANCE WITH THE TERMS
// OF SUCH LICENSE.
//
//
// COPYRIGHT (c) 1997 BY DIGITAL EQUIPMENT CORPORATION.
// ALL RIGHTS RESERVED.
//

package dec.trek;

//
//
// Code. For building a method call to be inserted in user's code
//
//
public final class Code extends Change
{
	// The opcode of each instruction. Note hack of appending 0 to 
	// avoid colliding with java reserved keywords (eg. return)
	public static final int nop = 0;
	public static final int aconst_null = 1;
	public static final int iconst_m1 = 2;
	public static final int iconst_0 = 3;
	public static final int iconst_1 = 4;
	public static final int iconst_2 = 5;
	public static final int iconst_3 = 6;
	public static final int iconst_4 = 7;
	public static final int iconst_5 = 8;
	public static final int lconst_0 = 9;
	public static final int lconst_1 = 10;
	public static final int fconst_0 = 11;
	public static final int fconst_1 = 12;
	public static final int fconst_2 = 13;
	public static final int dconst_0 = 14;
	public static final int dconst_1 = 15;
	public static final int bipush = 16;
	public static final int sipush = 17;
	public static final int ldc = 18;
	public static final int ldc_w = 19;
	public static final int ldc2_w = 20;
	public static final int iload = 21;
	public static final int lload = 22;
	public static final int fload = 23;
	public static final int dload = 24;
	public static final int aload = 25;
	public static final int iload_0 = 26;
	public static final int iload_1 = 27;
	public static final int iload_2 = 28;
	public static final int iload_3 = 29;
	public static final int lload_0 = 30;
	public static final int lload_1 = 31;
	public static final int lload_2 = 32;
	public static final int lload_3 = 33;
	public static final int fload_0 = 34;
	public static final int fload_1 = 35;
	public static final int fload_2 = 36;
	public static final int fload_3 = 37;
	public static final int dload_0 = 38;
	public static final int dload_1 = 39;
	public static final int dload_2 = 40;
	public static final int dload_3 = 41;
	public static final int aload_0 = 42;
	public static final int aload_1 = 43;
	public static final int aload_2 = 44;
	public static final int aload_3 = 45;
	public static final int iaload = 46;
	public static final int laload = 47;
	public static final int faload = 48;
	public static final int daload = 49;
	public static final int aaload = 50;
	public static final int baload = 51;
	public static final int caload = 52;
	public static final int saload = 53;
	public static final int istore = 54;
	public static final int lstore = 55;
	public static final int fstore = 56;
	public static final int dstore = 57;
	public static final int astore = 58;
	public static final int istore_0 = 59;
	public static final int istore_1 = 60;
	public static final int istore_2 = 61;
	public static final int istore_3 = 62;
	public static final int lstore_0 = 63;
	public static final int lstore_1 = 64;
	public static final int lstore_2 = 65;
	public static final int lstore_3 = 66;
	public static final int fstore_0 = 67;
	public static final int fstore_1 = 68;
	public static final int fstore_2 = 69;
	public static final int fstore_3 = 70;
	public static final int dstore_0 = 71;
	public static final int dstore_1 = 72;
	public static final int dstore_2 = 73;
	public static final int dstore_3 = 74;
	public static final int astore_0 = 75;
	public static final int astore_1 = 76;
	public static final int astore_2 = 77;
	public static final int astore_3 = 78;
	public static final int iastore = 79;
	public static final int lastore = 80;
	public static final int fastore = 81;
	public static final int dastore = 82;
	public static final int aastore = 83;
	public static final int bastore = 84;
	public static final int castore = 85;
	public static final int sastore = 86;
	public static final int pop = 87;
	public static final int pop2 = 88;
	public static final int dup = 89;
	public static final int dup_x1 = 90;
	public static final int dup_x2 = 91;
	public static final int dup2 = 92;
	public static final int dup2_x1 = 93;
	public static final int dup2_x2 = 94;
	public static final int swap = 95;
	public static final int iadd = 96;
	public static final int ladd = 97;
	public static final int fadd = 98;
	public static final int dadd = 99;
	public static final int isub = 100;
	public static final int lsub = 101;
	public static final int fsub = 102;
	public static final int dsub = 103;
	public static final int imul = 104;
	public static final int lmul = 105;
	public static final int fmul = 106;
	public static final int dmul = 107;
	public static final int idiv = 108;
	public static final int ldiv = 109;
	public static final int fdiv = 110;
	public static final int ddiv = 111;
	public static final int irem = 112;
	public static final int lrem = 113;
	public static final int frem = 114;
	public static final int drem = 115;
	public static final int ineg = 116;
	public static final int lneg = 117;
	public static final int fneg = 118;
	public static final int dneg = 119;
	public static final int ishl = 120;
	public static final int lshl = 121;
	public static final int ishr = 122;
	public static final int lshr = 123;
	public static final int iushr = 124;
	public static final int lushr = 125;
	public static final int iand = 126;
	public static final int land = 127;
	public static final int ior = 128;
	public static final int lor = 129;
	public static final int ixor = 130;
	public static final int lxor = 131;
	public static final int iinc = 132;
	public static final int i2l = 133;
	public static final int i2f = 134;
	public static final int i2d = 135;
	public static final int l2i = 136;
	public static final int l2f = 137;
	public static final int l2d = 138;
	public static final int f2i = 139;
	public static final int f2l = 140;
	public static final int f2d = 141;
	public static final int d2i = 142;
	public static final int d2l = 143;
	public static final int d2f = 144;
	public static final int int2byte = 145;
	public static final int int2char = 146;
	public static final int int2short = 147;
	public static final int lcmp = 148;
	public static final int fcmpl = 149;
	public static final int fcmpg = 150;
	public static final int dcmpl = 151;
	public static final int dcmpg = 152;
	public static final int ifeq = 153;
	public static final int ifne = 154;
	public static final int iflt = 155;
	public static final int ifge = 156;
	public static final int ifgt = 157;
	public static final int ifle = 158;
	public static final int if_icmpeq = 159;
	public static final int if_icmpne = 160;
	public static final int if_icmplt = 161;
	public static final int if_icmpge = 162;
	public static final int if_icmpgt = 163;
	public static final int if_icmple = 164;
	public static final int if_acmpeq = 165;
	public static final int if_acmpne = 166;
	public static final int goto_ = 167;
	public static final int jsr = 168;
	public static final int ret = 169;
	public static final int tableswitch = 170;
	public static final int lookupswitch = 171;
	public static final int ireturn = 172;
	public static final int lreturn = 173;
	public static final int freturn = 174;
	public static final int dreturn = 175;
	public static final int areturn = 176;
	public static final int return_ = 177;
	public static final int getstatic = 178;
	public static final int putstatic = 179;
	public static final int getfield = 180;
	public static final int putfield = 181;
	public static final int invokevirtual = 182;
	public static final int invokespecial = 183;
	public static final int invokestatic = 184;
	public static final int invokeinterface = 185;
	public static final int Unused1 = 186;
	public static final int new_ = 187;
	public static final int newarray = 188;
	public static final int anewarray = 189;
	public static final int arraylength = 190;
	public static final int athrow = 191;
	public static final int checkcast = 192;
	public static final int instanceof_ = 193;
	public static final int monitorenter = 194;
	public static final int monitorexit = 195;
	public static final int wide = 196;
	public static final int multianewarray = 197;
	public static final int ifnull = 198;
	public static final int ifnonnull = 199;
	public static final int goto_w = 200;
	public static final int jsr_w = 201;
	public static final int breakpoint = 202;

	// Add code after specified stmt.
	// chid = change ID to get this addition
	public static Code addAfter(String chid, Statement stmt)
	{
		// Chk if user trying to insert code at inaccessible location
		switch (stmt.type) {

		// After-if/endloop is inaccess and context is imprecise (vs Return)
		case Trek.ST_IF:
		case Trek.ST_ENDDO:
		case Trek.ST_ENDFOR:
		case Trek.ST_ENDWHILE:

		// Unconditional goto
		case Trek.ST_BREAK:
		case Trek.ST_CONTINUE:
			throw new TrekException
				("Code cannot be inserted after a jumping statement");

		// User would equate after these to start of content
		case Trek.ST_TRY:
		case Trek.ST_CATCH:
		case Trek.ST_FINALLY:
		case Trek.ST_LABEL:
		case Trek.ST_CASE:
		case Trek.ST_DO:
		case Trek.ST_FOR:
		case Trek.ST_WHILE:
		case Trek.ST_THEN:
		case Trek.ST_ELSE:
			return addBefore(chid, stmt.next());
		}

		// Do the requested work
		return new Code(chid, stmt, null, Trek.ST_AFTER);
	}

	// Add code at specified instruction (ie. after its stack args are set up)
	public static Code addAt(String chid, Instruction inst)
	{
		return new Code(chid, inst.parent, inst, Trek.ST_AT);
	}

	// Add code at start of statement
	public static Code addBefore(String chid, Statement stmt)
	{
		return new Code(chid, stmt, null, Trek.ST_BEFORE);
	}

	// Append a byte array containing inst bytes
	public void append(byte insts[])
	{
		System.arraycopy(insts, 0, newCode, newCodeLen, insts.length);
		newCodeLen += insts.length;
	}

	// Append an argument-less instruction to code stream
	// opcode = sort of instruction to insert
	public void append(int opcode)
	{
		if (Instruction.hasArgs(opcode))
			throw new TrekException
				(Instruction.toName(opcode) + " is not a 0-arg instruction");
		newCode[newCodeLen++] = (byte)opcode;
	}

	// Append an instruction to code stream (convenience routine)
	// opcode = sort of instruction to insert
	// arg = int arg
	public void append(int opcode, int arg)
	{
		append(opcode, new Integer(arg));
	}

	// Append an instruction to code stream (convenience routine)
	// opcode = sort of instruction to insert
	// arg1 = 1st arg
	// arg2 = 2nd arg is int
	public void append(int opcode, Object arg1, int arg2)
	{
		// Get data type and number of dimensions
		switch (opcode) {
		case multianewarray:
			if (arg2<1 || arg2>255)
				throw new TrekException("multianewarray dimensions must be 1 to 255");
			writeTypeInst(opcode, arg1);
			newCode[newCodeLen++] = (byte)arg2;
			break;

		// This call-inst has args and a 0 after usual stuff
		case invokeinterface:
			if (arg2<1 || arg2>255)
				throw new TrekException("invokeinterface args# must be 1 to 255");
			writeMemberInst(opcode, arg1, false, false);
			newCode[newCodeLen++] = (byte)arg2;
			newCode[newCodeLen++] = (byte)0;
			break;

		// Incr a local by 8 or 16-bit signed value
		case iinc:
			if (arg2==0 || arg2!=(short)arg2)
				throw new TrekException
					("iinc delta is 0 or has more than 16 significant bits");

			// Delta ok, do work.
			Local loc = validateLocalInst(opcode, arg1, 'I');
			writeIincInst(loc.idx, arg2);
			break;

		default:
			throw new TrekException
				(Instruction.toName(opcode) + " is not a 2-arg instruction");
		}
	}

	// Append an instruction to code stream
	// opcode = sort of instruction to insert
	// arg = the member, local, constant, or immed val of this inst
	public void append(int opcode, Object arg)
	{

		// Integer byte arg
		switch (opcode) {
		case bipush:
			int val;
			if (arg instanceof IntegerConstant)
				arg = ((IntegerConstant)arg).getObject();
			if (!(arg instanceof Integer)
				|| (val=((Integer)arg).intValue())<-127 || val>127)
				throw new TrekException
					(Instruction.toName(opcode) + " requires a byte arg");
			writeByteInst(opcode, (byte)val);
			break;
		case newarray:
			if (!(arg instanceof Integer)
				|| (val=((Integer)arg).intValue())<4 || val>11)
				throw new TrekException
					("newarray's arg must be 4 thru 11");
			writeByteInst(opcode, val);
			break; 

		// Integer short arg
		case sipush:
			if (arg instanceof IntegerConstant)
				arg = ((IntegerConstant)arg).getObject();
			if (!(arg instanceof Integer)
				|| (val=((Integer)arg).intValue())<-32381 || val>32381)
				throw new TrekException
					(Instruction.toName(opcode) + " requires a short arg");
			writeShortInst(opcode, val);
			break;

		// Any constant. If starting with ref, get at real thing.
		// Because add actually only adds when necessary, no risk of
		// creating duplicate constants from this.
		case ldc:
		case ldc_w:
			CpInfo cpi;
			if (arg instanceof ValueRef)
				arg = ((ValueRef)arg).getObject();

			// Have raw type, see if consistent with ldc
			if (arg instanceof String)
				cpi = StringConstant.add((String)arg, cf);
			else if (arg instanceof Integer)
				cpi = IntegerConstant.add(((Integer)arg).intValue(), cf);
			else if (arg instanceof Float)
				cpi = FloatConstant.add(((Float)arg).floatValue(), cf);
			else throw new TrekException("Invalid data type for ldc");

			// Chk range if called with ldc. If ok, write the inst
			if (opcode==ldc)
			{
				if (cpi.idx>255)
					throw new TrekException("ldc requires pool index < 256");
				writeByteInst(opcode, cpi.idx);
			}
			else writeShortInst(opcode, cpi.idx);
			break;

		// Process 2-word constants
		case ldc2_w:
			if (arg instanceof ValueRef)
				arg = ((ValueRef)arg).getObject();

			// Have raw type, see if consistent with ldc2_w
			if (arg instanceof Double)
				cpi = DoubleConstant.add(((Double)arg).doubleValue(), cf);
			else if (arg instanceof Long)
				cpi = LongConstant.add(((Long)arg).longValue(), cf);
			else throw new TrekException("Invalid data type for ldc");

			// Write the inst
			writeShortInst(opcode, cpi.idx);
			break;

		// Arg is lvt index
		case iload:
		case istore:
			writeLocalInst(opcode, arg, 'I');
			break;
		case lload:
		case lstore:
			writeLocalInst(opcode, arg, 'J');
			break;
		case fstore:
		case fload:
			writeLocalInst(opcode, arg, 'F');
			break;
		case dload:
		case dstore:
			writeLocalInst(opcode, arg, 'D');
			break;
		case aload:
		case astore:
			writeLocalInst(opcode, arg, 'L');
			break;

		// Branch instructions contain relative address
		case Code.ifeq:
		case Code.ifne:
		case Code.iflt:
		case Code.ifge:
		case Code.ifgt:
		case Code.ifle:
		case Code.if_icmpeq:
		case Code.if_icmpne:
		case Code.if_icmplt:
		case Code.if_icmpge:
		case Code.if_icmpgt:
		case Code.if_icmple:
		case Code.if_acmpeq:
		case Code.if_acmpne:
		case Code.goto_:
		case Code.jsr:
		case Code.ifnull:
		case Code.ifnonnull:
			if (!(arg instanceof Integer)
				|| (val=((Integer)arg).intValue())<-32381 || val>32381)
				throw new TrekException
					(Instruction.toName(opcode) + " requires a 16-bit integer arg");
			writeShortInst(opcode, val);
			break;
		
		// These have 32-bit relative address
		case Code.goto_w:
		case Code.jsr_w:
			if (!(arg instanceof Integer))
				throw new TrekException
					(Instruction.toName(opcode) + " requires an integer arg");
			val = ((Integer)arg).intValue();
			writeIntegerInst(opcode, val);
			break;

		// Members.
		case getstatic:
		case putstatic:
			writeMemberInst(opcode, arg, true, true);
			break;
		case getfield:
		case putfield:
			writeMemberInst(opcode, arg, false, true);
			break;
		case invokestatic:
			writeMemberInst(opcode, arg, true, false);
			break;
		case invokespecial:
		case invokevirtual:
			writeMemberInst(opcode, arg, false, false);
			break;

		// Arg is class or array
		case new_:
		case anewarray:
		case checkcast:
		case instanceof_:
			writeTypeInst(opcode, arg);
			break;

		default:
			throw new TrekException
				(Instruction.toName(opcode) + " is not a 1-arg instruction");
		}
	}

	// Create code object
	// chid = change Id
	// st = stmt to modify
	// in = ins pt is specific instruction
	// typ = at, before, after
	Code(String chid, Statement st, Instruction in, int typ)
	{
		// Chk arg consistency
		if (st==null && in==null)
			throw new TrekException("Insert point not specified");

		// Save change ID
		if (chid==null)
			chid = "";
		changeId = chid;

		// Save other input properties
		stmt = st;
		inst = in;
		meth = st.parent;			// Convenience
		cf = meth.parent;			// Convenience
		priority = Statement.plev_normal;
		setInsertPoint(typ);
	}									// End addCode

	// Done building code, insert the code
	public void done()
	{
		doneInsert();
	}

	// Real loads only needed in Call
	protected String loadInsertPoint(String term, String refdesc)
	{
		throw new TrekException("Not allowed in Code.get");
	}
	protected void loadField(String qname, String name, String desc,
		String refdesc, boolean is_static)
	{
	}
	protected String loadInteger(int ival)
	{
		return "I";
	}
	protected void loadLocal(Local loc, String desc)
	{
	}
	protected void loadMethod(String qname, String name, String desc,
		int thisload, boolean is_static)
	{
	}
	protected void loadPoolConstant(CpInfo cpi)
	{
	}
	protected void loadThis()
	{
	}

	// Validate instruction with Local arg into instruction stream.
	// opcode = inst's opcode
	// arg = the arg to validate/add
	// dt = the data type code of opcode
	// Returns local should use in upcoming instruction
	private Local validateLocalInst(int opcode, Object arg, int dt)
	{
		// Arg must be a local var
		if (!(arg instanceof Local))
			throw new TrekException
				(Instruction.toName(opcode) + " requires a Local arg");

		// It must be defined in this method and active
		Local loc = (Local)arg;
		if (loc.parent!=meth)
			throw new TrekException
				(loc.name + " is not defined in " + meth.toName());
		if (!loc.isActive(stmt.start+stmt.insts.length))
			throw new TrekException(loc.name + " is referenced outside its scope");

		// And it must have right data type (any size int ok for int local inst)
		// All integer data, incl booleans, processed by ixxx insts
		int ch = Datum.promote(loc.desc).charAt(0);
		if (ch=='Z') ch = 'I';
		if (ch=='[') ch = 'L';		// Canonicalize array as obj
		if (ch!=dt)
			throw new TrekException(loc.name + " has wrong data type");
		return loc;
	}

	// Add instruction with 32-bit arg into instruction stream.
	// opcode = inst's opcode
	// val = 32-bit value to hi-endian-ize
	private void writeIntegerInst(int opcode, int val)
	{
		// Put high-order byte of ref, then low-order byte in newCode
		newCode[newCodeLen++] = (byte)opcode;
		newCodeLen = Instruction.writeInt(val, newCode, newCodeLen);
	}

	// Add instruction with Local arg into instruction stream.
	// opcode = inst's opcode
	// arg = the arg to validate/add
	// dt = the data type code of opcode
	private void writeLocalInst(int opcode, Object arg, int dt)
	{
		Local loc = validateLocalInst(opcode, arg, dt);
		writeByteInst(opcode, loc.idx);
	}

	// Add instruction with Member arg into instruction stream.
	// opcode = inst's opcode
	// arg = the arg to validate/add
	// isstat = true if static member required
	// isfld = ture if field required
	private void writeMemberInst(int opcode, Object arg,
		boolean isstat, boolean isfld)
	{
		// Arg must be a field
		if (isfld && !(arg instanceof Field || arg instanceof FieldRef))
			throw new TrekException
				(Instruction.toName(opcode) + " requires a field arg");

		// Arg must be a method
		if (!isfld && !(arg instanceof Method || arg instanceof MethodRef))
			throw new TrekException
				(Instruction.toName(opcode) + " requires a method arg");

		// If starting with ref and cant get member, cant chk modifiers
		// and need to chk/add using member ref itself rather than mem
		Member mem;
		if (arg instanceof MemberRef)
		{
			MemberRef refarg = (MemberRef)arg;
			try {
				mem = refarg.getObject(0);
			}
			catch (TrekException trex) {
				MemberRef ref = MemberRef.add(refarg, cf);
				writeShortInst(opcode, ref.idx);
				return;
			}
		}
		else mem = (Member)arg;

		// It must match static vs. instance
		if (isstat && !mem.hasModifier(Trek.ACC_STATIC))
			throw new TrekException(mem.toName() + " is not a static member");
		if (!isstat && mem.hasModifier(Trek.ACC_STATIC))
			throw new TrekException(mem.toName() + " is not an instance member");

		// Find/create mem ref in pool and write inst
		MemberRef ref = MemberRef.add(mem, cf);
		writeShortInst(opcode, ref.idx);
	}

	// Write inst that uses data type as arg. However note that data type of
	// class is its qualified class name and data type of array is a descriptor
	private void writeTypeInst(int opcode, Object arg)
	{
		// Access data assoc with arg
		String desc;
		if (arg instanceof ClassFile)
			desc = ((ClassFile)arg).toInternalName();
		else if (arg instanceof TypeRef)
			desc = ((TypeRef)arg).toInternalString();

		// String is array descriptor or external class name.
		// Internalize latter, and syntax chk both
		else if (arg instanceof String)
		{
			desc = (String)arg;
			if (!desc.startsWith("[")) desc.replace('.', '/');
			meth.parent.toDef(null, desc, 0);
		}

		// Fields, methods, and locals can only supply an array
		else {
			if (arg instanceof Member)
				desc = ((Member)arg).toDesc();
			else if (arg instanceof Local)
				desc = ((Local)arg).desc;
			else if (arg instanceof MemberRef)
				desc = ((MemberRef)arg).toDesc();
			else desc = null;
			if (desc!=null && desc.charAt(0)!='[')
				throw new TrekException
					("The local, field, or method is not an array"); 
		}

		// See if valid arg
		switch (opcode) {
		case multianewarray:
			if (desc==null || desc.charAt(0)!='[')
				throw new TrekException("multianewarray requires an array type");
			break;
		case new_:
			if (desc==null || desc.charAt(0)=='[')
				throw new TrekException("new requires a class");
			break;
		case anewarray:
		case checkcast:
		case instanceof_:
			if (desc==null)
				throw new TrekException
					(Instruction.toName(opcode) + " requires a class or array arg");
		}

		// Find/get pool entry and write the inst
		CpInfo cpi = TypeRef.add(desc, cf);
		writeShortInst(opcode, cpi.idx);
	}

}
