//
// THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND  MAY
// BE USED OR COPIED ONLY IN ACCORDANCE WITH THE TERMS
// OF SUCH LICENSE.
//
//
// COPYRIGHT (c) 1997,1998 BY DIGITAL EQUIPMENT CORPORATION.
// ALL RIGHTS RESERVED.
//

// Import the Trek class library and any other libraries used
import dec.trek.*;
import java.io.*;

//
//
// dump -- decompile and/or disassemble java classfiles
// Notes:
//	Sub-class Trek because need to override atStartOf in order
//	to use automatic scanning provided by doTrek
//
class dump extends Trek
{
	int flags;					// Options to use during dump

	// This is called by doTrek as the scan reaches each classfile.
	// It creates the .dmp file for the specified classfile, in the
	// directory specified in -op (or the current directory if -op omitted)
	// cf = current object in scan
	protected void atStartOf(ClassFile cf)
	{
		cf.dump(flags);
	}

	// Process command-line args unique to dump application
	// This method is called when Trek.getCmdLine doesnt recognize an arg
	// Returns:
	//	index of next arg to process, or 0 for didnt recognize argv[i]
	protected int getCmdLineArg(String argv[], int i)
	{
		// Chk for Include switch
		if (argv[i].equals("-inc"))
		{
			if (i>argv.length-2)
				throw new TrekException("No value specified for -inc");
			String arg = argv[i+1];

			// Convert arg i+1 to binary flags
			flags = 0;
			if (arg.indexOf('a') >= 0) flags |= DUMP_ATTR;
			if (arg.indexOf('i') >= 0) flags |= DUMP_INST;
			if (arg.indexOf('p') >= 0) flags |= DUMP_POOL;
			if (arg.indexOf('s') >= 0) flags |= DUMP_STMT;
			return i + 2;			// Ate 2 args overall
		}
		return 0;					// Not a custom arg
	}

	// Do the scan to dump class files
	// argv = each arg on the cmd line
	public static void main(String argv[])
	{
		// Create a trek object, get dump cmd line, and do 1-level
		// (classfiles only) scan of what was read in when doTrek called
		// initTrek.
		dump dtrek = new dump();
		try {
			dtrek.getCmdLine(argv);
			dtrek.doTrek(1);
		}

		// Catch any error thrown by Trek package, and output it to console.
		catch (Throwable e) {
			System.out.println(dtrek.toErrorMessage(e));
			System.exit(1);
		}
	}

}

